﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Text
Imports System.Web.UI.WebControls
Imports Microsoft.SharePoint
Imports Microsoft.SharePoint.WebControls


Namespace OfficeSpaceFieldTypes

  Public Class FieldEmployeeStatus
	  Inherits SPFieldText
	Public Sub New(ByVal fields As SPFieldCollection, ByVal fieldName As String)
		MyBase.New(fields, fieldName)
	End Sub

	Public Sub New(ByVal fields As SPFieldCollection, ByVal typeName As String, ByVal displayName As String)
		MyBase.New(fields, typeName, displayName)
	End Sub

	Public Overrides ReadOnly Property FieldRenderingControl() As BaseFieldControl
	  Get
		Dim ctr As BaseFieldControl = New EmployeeStatusFieldControl()
		ctr.FieldName = Me.InternalName
		Return ctr
	  End Get
	End Property
	Public Overrides ReadOnly Property DefaultValue() As String
	  Get
		Return "Full-time Employee"
	  End Get
	End Property
  End Class

  Public Class EmployeeStatusFieldControl
	  Inherits BaseFieldControl
	Protected lstEmployeeStatus As RadioButtonList
	Protected Overrides ReadOnly Property DefaultTemplateName() As String
	  Get
		Return "EmployeeStatusRenderingTemplate"
	  End Get
	End Property

	Protected Overrides Sub CreateChildControls()
	  MyBase.CreateChildControls()
	  lstEmployeeStatus = CType(TemplateContainer.FindControl("lstEmployeeStatus"), RadioButtonList)
	  If lstEmployeeStatus IsNot Nothing Then
		lstEmployeeStatus.Items.Clear()
		lstEmployeeStatus.Items.Add("Full-time Employee")
		lstEmployeeStatus.Items.Add("Part-time Employee")
		' check to see if contractors are allowed
		Dim AllowContactors As Boolean = CBool(Me.Field.GetCustomProperty("AllowContractors"))
		If AllowContactors Then
		  lstEmployeeStatus.Items.Add("Contractor")
		End If
		' check to see if interns are allowed
		Dim AllowInterns As Boolean = CBool(Me.Field.GetCustomProperty("AllowInterns"))
		If AllowInterns Then
		  lstEmployeeStatus.Items.Add("Intern")
		End If
	  End If
	End Sub

	Public Overrides Property Value() As Object
	  Get
		Me.EnsureChildControls()
		Return lstEmployeeStatus.SelectedValue
	  End Get
	  Set(ByVal value As Object)
		Me.EnsureChildControls()
		lstEmployeeStatus.Items.FindByValue(ItemFieldValue.ToString()).Selected = True
	  End Set
	End Property
  End Class
End Namespace
