﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Text
Imports System.Text.RegularExpressions
Imports System.Web.UI.WebControls
Imports Microsoft.SharePoint
Imports Microsoft.SharePoint.WebControls


Namespace OfficeSpaceFieldTypes

  Public Class FieldSocialSecurityNumber
	  Inherits SPFieldText
	Public Sub New(ByVal fields As SPFieldCollection, ByVal fieldName As String)
		MyBase.New(fields, fieldName)
	End Sub

	Public Sub New(ByVal fields As SPFieldCollection, ByVal typeName As String, ByVal displayName As String)
		MyBase.New(fields, typeName, displayName)
	End Sub

	Public Overrides ReadOnly Property FieldRenderingControl() As BaseFieldControl
	  Get
		Dim ctr As BaseFieldControl = New SocialSecurityNumberFieldControl()
		ctr.FieldName = Me.InternalName
		Return ctr
	  End Get
	End Property

	Public Overrides Function GetValidatedString(ByVal value As Object) As String
	  Dim UserInput As String = value.ToString()
	  Dim SSN_RegularExpression As String = "^\d{3}-\d{2}-\d{4}$"
	  If (Me.Required OrElse (Not String.IsNullOrEmpty(UserInput))) And ((Not Regex.IsMatch(UserInput, SSN_RegularExpression))) Then
		Throw New SPFieldValidationException("SSN must be form of 123-45-6789")
	  End If
	  Return MyBase.GetValidatedString(value)
	End Function
  End Class

  Public Class SocialSecurityNumberFieldControl
	  Inherits BaseFieldControl
	Protected txtUserInput As TextBox
	Protected Overrides ReadOnly Property DefaultTemplateName() As String
	  Get
		Return "SocialSecurityNumberRenderingTemplate"
	  End Get
	End Property
	Protected Overrides Sub CreateChildControls()
	  MyBase.CreateChildControls()
	  txtUserInput = CType(Me.TemplateContainer.FindControl("txtUserInput"), TextBox)
	End Sub

	Public Overrides Property Value() As Object
	  Get
		Me.EnsureChildControls()
		Return txtUserInput.Text
	  End Get
	  Set(ByVal value As Object)
		Me.EnsureChildControls()
		txtUserInput.Text = CStr(Me.ItemFieldValue)
	  End Set
	End Property
  End Class
End Namespace
