﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Text
Imports System.Web.UI.WebControls
Imports Microsoft.SharePoint
Imports Microsoft.SharePoint.WebControls

Namespace OfficeSpaceFieldTypes

  Public Class FieldUnitedStatesAddress
	  Inherits SPFieldMultiColumn
	Public Sub New(ByVal fields As SPFieldCollection, ByVal fieldName As String)
		MyBase.New(fields, fieldName)
	End Sub

	Public Sub New(ByVal fields As SPFieldCollection, ByVal typeName As String, ByVal displayName As String)
		MyBase.New(fields, typeName, displayName)
	End Sub

	Public Overrides ReadOnly Property FieldRenderingControl() As BaseFieldControl
	  Get
		Dim ctr As BaseFieldControl = New UnitedStatesAddressFieldControl()
		ctr.FieldName = Me.InternalName
		Return ctr
	  End Get
	End Property
  End Class

  Public Class UnitedStatesAddressFieldControl
	  Inherits BaseFieldControl
	Protected Overrides ReadOnly Property DefaultTemplateName() As String
	  Get
		Return "UnitedStatesAddressRenderingTemplate"
	  End Get
	End Property
	Protected txtStreet As TextBox
	Protected txtCity As TextBox
	Protected txtState As TextBox
	Protected txtZipcode As TextBox


	Protected Overrides Sub CreateChildControls()
	  MyBase.CreateChildControls()
	  txtStreet = CType(Me.TemplateContainer.FindControl("txtStreet"), TextBox)
	  txtCity = CType(Me.TemplateContainer.FindControl("txtCity"), TextBox)
	  txtState = CType(Me.TemplateContainer.FindControl("txtState"), TextBox)
	  txtZipcode = CType(Me.TemplateContainer.FindControl("txtZipcode"), TextBox)
	End Sub

	Public Overrides Property Value() As Object
	  Get
		Me.EnsureChildControls()
		Dim mcv As New SPFieldMultiColumnValue(4)
		mcv(0) = txtStreet.Text
		mcv(1) = txtCity.Text
		mcv(2) = txtState.Text
		mcv(3) = txtZipcode.Text
		Return mcv
	  End Get
	  Set(ByVal value As Object)
		Me.EnsureChildControls()
		Dim mcv As SPFieldMultiColumnValue = CType(Me.ItemFieldValue, SPFieldMultiColumnValue)
		txtStreet.Text = mcv(0)
		txtCity.Text = mcv(1)
		txtState.Text = mcv(2)

		txtZipcode.Text = mcv(3)
	  End Set
	End Property
  End Class
End Namespace
